//constanst, classes, enums, and structs
#Define NoNeighbor 0xff;
#Define MaxPlayfieldWidth 30;
#Define MaxPlayfieldHeight 16;
#Define MaxPlayfieldDepth 4;
#Define TileSize 15;
#Define LEDSize 15;
#Define FaceSize 35;
#Define SecondsSpeed 1000;
#Define HourLength 3600;
#Define MinuteLength 60;
#Define WindowWidth 488;
#Define WindowHeight 388;
#Define FaceLevel 0x0;
#Define ValueLevel 0x1;
#Define BugLevel 0x2;
#Define DashSeperator 11;
#Define TimeSeperator 12;
#Define BoardTop 76;
#Define BoardLeft 16;
#Define FaceTop 8;
#Define FaceLeft 225;
#Define ScoreTop 16;
#Define ScoreLeft 344;
#Define TimeTop 16;
#Define TimeLeft 8;
#Define FreeBugTop 54;
#Define FreeBugLeft 190;
#Define FreeBugSpacing 30;

//Menu Items
#Define mnuNewID 200;
#Define mnuQuitID 201;
#Define mnuPauseID 202;
#Define mnuTilesetTermiteID 203;
#Define mnuTilesetClassicID 204;
#Define mnuOptionUseQMarkID 205;
#Define mnuLevelEasyID 206;
#Define mnuLevelMediumID 207;
#Define mnuLevelHardID 208;
#Define mnuLevelEasyTimedID 209;
#Define mnuLevelMediumTimedID 210;
#Define mnuLevelHardTimedID 211;
#Define mnuLevelEasierID 212;
#Define mnuLevelAlmostMediumID 213;
#Define mnuLevelHardlyID 214;
#Define mnuLevelHardOnezID 215;
#Define mnuLevelHardTwozID 216;
#Define mnuLevelNunzHarderID 217;
#Define mnuLevelMSBeginnerID 218;
#Define mnuLevelMSIntermediateID 219;
#Define mnuLevelMSExpertID 220;
#Define mnuLevelShowLevelStatsID 221;

//Timers
#Define timSecsID 300;
#Define timBugID 301;

Struct ScoreTime
{
	Unsigned Int D8;
	Unsigned Int D7;
	Unsigned Int D6;
	Unsigned Int D5;
	Unsigned Int D4;
	Unsigned Int D3;
	Unsigned Int D2;
	Unsigned Int D1;
}

enum eLED /* LEDs */
{
	LEDZero=0,
	LEDOne,
	LEDTwo,
	LEDThree,
	LEDFour,
	LEDFive,
	LEDSix,
	LEDSeven,
	LEDEight,
	LEDNine,
	LEDAll,
	LEDDash,
	LEDDot
}

enum eLevel /* Levels */
{
	LevelEasy=0,
	LevelMedium,
	LevelHard,
	LevelEasyTimed,
	LevelMediumTimed,
	LevelHardTimed,
	LevelEasier,
	LevelAlmostMedium,
	LevelHardly,
	LevelHardOnez,
	LevelHardTwoz,
	LevelNunzHarder,
	LevelMSBeginner,
	LevelMSIntermediate,
	LevelMSExpert
}

enum eTimeStyle /* Timing Styles */
{
	Ascending=0,
	Descending
}

Enum eTile /* Tiles */
{
	TileZero=0,
	TileOne,
	TileTwo,
	TileThree,
	TileFour,
	TileFive,
	TileSix,
	TileSeven,
	TileEight,
	TileCovered,
	TileOutOfBounds,
	TileTermite,
	TileFlag,
	TileQMark,
	TileBoom,
	TileWrong,
	TileFace,
	TilePreBug,
	TilePostBug,
	TileBoardBug,
	TileFreeBug
}

Enum eTileset /* Tile Sets */
{
	Termite=0,
	Classic
}

Enum eBoardLevel
{
	LevelFace=0,
	LevelValue,
	LevelBug,
	LevelBasement
}

Enum eDirection /* Directions */
{
	DirN=0,
	DirNE,
	DirE,
	DirSE,
	DirS,
	DirSW,
	DirW,
	DirNW,
	DirX
}

Enum eFace /* Faces */
{
	FaceShadow=0,
	FaceHappy,
	FaceBoom,
	FaceFreeze,
	FaceUnsure,
	FaceCap,
	FaceOhh,
	FaceCrazy,
	FaceSleepy,
	FaceTerror,
	FaceFrown,
	FaceRaspberry,
	FaceEyePatch
}

Enum eGameOver /* Game Overs */
{
	GameOverWinner=0,
	GameOverTermite,
	GameOverTime,
	GameOverNot
}

Enum eDoodleMove /* Doodle Moves */
{
	OverTilePre=0,
	OverTilePost,
	PressTile,
	MoveDoodle
}


Struct DoodleBug
{
	Int Active;
	Int X;
	Int Y;
	eDoodleMove CurMove;
	Int Moves;
}

Class TTLevel /* Game Level Class Definition */
{
	Public:
	Declare TTLevel();
	Declare _TTLevel();
	Declare SetLevel(eLevel Value);
	Declare Name(),String;
	Declare Width(),Int;
	Declare Height(),Int;
	Declare XStart(),Int;
	Declare XEnd(),Int;
	Declare YStart(),Int;
	Declare YEnd(),Int;	
	Declare StartBug(),Int;
	Declare BoardBugs(),Int;
	Declare FreeBugs(),Int;
	Declare BugMoves(),Int;
	Declare Termites(),Int;
	Declare StartTime(),Int;
	Declare Timing(),eTimeStyle;	
	Declare FigureOffset(Int BSize,Int MSize),Int;
	
	Protected:
	String _Name;
	Int _Width;
	Int _Height;
	Int _XStart;
	Int _XEnd;
	Int _YStart;
	Int _YEnd;
	Int _StartBug;
	Int _BoardBugs;
	Int _FreeBugs;
	Int _BugMoves;
	Int _Termites;
	Int _StartTime;
	eTimeStyle _Timing;	
			
}

Class TTWin : C2DScreen
{
	Public:
	
	Declare Init();
	Declare TTWin();
	
	Protected:
	
	C2DSurface *BackSurf;
	eTile Board[MaxPlayfieldDepth,MaxPlayfieldWidth,MaxPlayfieldHeight];
	DoodleBug BoardBug[5];
	Unsigned Int BugCursor;
	Int BugInHand;
	Int BugRunning;
	eFace CurrentFace;
	eTileSet CurrentTileset;
	Int DrawingInProgress;
	Int FreeBug[4];
	C2DSprite *GameFace;
	Int GameInProgress;
	eGameOver GameOverFlag;
	Int IgnoreNextLUp;
	Int IgnoreNextRUp;
	Int InitCompleted;
	C2DSprite *LED;
	C2DSprite *LEDFrame;
	TTLevel *Level;
	Int OKToBugStep;
	Int PauseMode;
	C2DSprite *Tile;
	Int TTTime;
	Int TTScore;
	Int UseQuestionMark;
	Int UserInputSuspended;
	Declare AllBugsInactive(),Int;
	Declare BoardDblClk(Point Where);
	Declare BoardLClick(Point Where);
	Declare BoardRClick(Point Where);
	Declare BoardRect(),Rect;
	Declare CalculateCellValues();
	Declare CheckLevelMenuItem(Int WhichOne);
	Declare ClearBoard();
	Declare DisplayLevelStats();
	Declare DoDraw();
	Declare Draw();
	Declare DrawBoard();
	Declare DrawFace();
	Declare DrawFrames();
	Declare DrawFreeBugs();
	Declare DrawScore();
	Declare DrawTime();
	Declare FaceBoard();
	Declare FaceRect(),Rect;
	Declare FreebugClick(Int WhichBug);
	Declare GameOver(eGameOver Condition);
	Declare GetCell(Point MouseClick),Point;
	Declare GetNeighbor(Point WhichCell,eDirection WhichDir),Point;
	Declare Infest();
	Declare InfestationEliminated(),Int;
	Declare InitFreeBugs();
	Declare IsCellValid(Point WhichCell),Int;
	Declare IsClickOnFreeBug(Point MouseClick),Point;
	Declare IsPointInRectangle(Point WhichPoint, Rect WhichRect),Int;
	Declare LoadMenus();
	Declare LoadSprites();
	Declare LoadTileset();
	Declare Neighborize(),Int;
	Declare NeighborsRevealed(Point WhichCell),Int;
	Declare NewBoard();	
	Declare NewGame();
	Declare NextBugMove(Point Cell),Point;
	Declare Virtual OnClose(),Int;
	Declare Virtual OnLButtonDown(Int x,Int y,Int flags),Int;
	Declare Virtual OnLButtonDblClk(Int x,Int y,Int Flags),Int;
	Declare Virtual OnLButtonUp(Int x,Int y,Int flags),Int;
	Declare Virtual OnMenuPick(Int nID),Int;
	Declare Virtual OnPaint(),Int;
	Declare Virtual OnRButtonDown(Int x,Int y,Int Flags),Int;
	Declare Virtual OnRButtonUp(Int x,Int y,Int flags),Int;	
	Declare Virtual OnTimer(Int nIDEvent),Int;
	Declare RandomCell(),Point;
	Declare RevealAllNeighbors(Point WhichCell);
	Declare RevealBoard();
	Declare RandomFace();
	Declare RunBugs();
	Declare ScoreDigitToLEDIndex(String ScoreDigit),eLED;
	Declare SeedBoardBugs();
	Declare StarterBoard();
	Declare StartBugs();
	Declare StopBugs();
	
}
